;***************************************************************************************************************

;This software is provided in an AS IS condition,NO WARRANTIES in any form apply to this software.

; picmicrolab.com 8.9.2017
;***************************************************************************************************************
;Running LEDs with PIC16F877A
;
;--------------------------------------------------------------------------------------------------------------	
		LIST 	P=PIC16F877A
		include	P16f877A.inc

 __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _LVP_OFF & _DEBUG_OFF & _CPD_OFF

	    org		0x00
reset:	goto start
	    org		0x04
start:

	bsf			STATUS, RP0
	bcf			STATUS, RP1

	clrf		TRISC
	clrf		TRISD

	movlw		0x07;PORTB is  Input - 3 Lower bits
	movwf		TRISB

	bcf			STATUS, RP0
	movlw		0x00 ;	Clear Ports
	movwf		PORTC
	movwf		PORTD
;----------------------------------------------------
LOOP:
btfss	PORTB,0x00
call	Pattern_2

btfsc	PORTB,0x00
call	Pattern_1
goto	LOOP
;-----------------------------------------------------


;------------------------------------
Pattern_1:
;---------
movlw 0x01
movwf PORTC
movlw 0x80
movwf PORTD
call  delay
movlw 0x02
movwf PORTC
movlw 0x40
movwf PORTD
call  delay
;----------
movlw 0x04
movwf PORTC
movlw 0x20
movwf PORTD
call  delay
movlw 0x08
movwf PORTC
movlw 0x10
movwf PORTD
call  delay
;----------
movlw 0x10
movwf PORTC
movlw 0x08
movwf PORTD
call  delay
movlw 0x20
movwf PORTC
movlw 0x04
movwf PORTD
call  delay
;----------
movlw 0x40
movwf PORTC
movlw 0x02
movwf PORTD
call  delay
movlw 0x80
movwf PORTC
movlw 0x01
movwf PORTD
call  delay
;----------
return
;------------------------------------
Pattern_2:
;---------
movlw 0x00
movwf PORTC
movlw 0x80
movwf PORTD
call  delay
movlw 0x00
movwf PORTC
movlw 0xC0
movwf PORTD
call  delay
;----------
movlw 0x00
movwf PORTC
movlw 0xE0
movwf PORTD
call  delay
movlw 0x00
movwf PORTC
movlw 0xF0
movwf PORTD
call  delay
;----------
movlw 0x00
movwf PORTC
movlw 0x78
movwf PORTD
call  delay
movlw 0x00
movwf PORTC
movlw 0x3C
movwf PORTD
call  delay
;----------
movlw 0x00
movwf PORTC
movlw 0x1E
movwf PORTD
call  delay

movlw 0x00
movwf PORTC
movlw 0x0F
movwf PORTD
call  delay
;----------
movlw 0x80
movwf PORTC
movlw 0x07
movwf PORTD
call  delay

movlw 0xC0
movwf PORTC
movlw 0x03
movwf PORTD
call  delay
;----------
movlw 0xE0
movwf PORTC
movlw 0x01
movwf PORTD
call  delay

movlw 0xF0
movwf PORTC
movlw 0x00
movwf PORTD
call  delay
;----------
movlw 0x78
movwf PORTC
movlw 0x00
movwf PORTD
call  delay

movlw 0x3C
movwf PORTC
movlw 0x00
movwf PORTD
call  delay
;----------
movlw 0x1E
movwf PORTC
movlw 0x00
movwf PORTD
call  delay

movlw 0x0F
movwf PORTC
movlw 0x00
movwf PORTD
call  delay
;----------
movlw 0x07
movwf PORTC
movlw 0x00
movwf PORTD
call  delay

movlw 0x03
movwf PORTC
movlw 0x00
movwf PORTD
call  delay
;----------
movlw 0x01
movwf PORTC
movlw 0x00
movwf PORTD
call  delay

movlw 0x00
movwf PORTC
movlw 0x00
movwf PORTD
call  delay
;----------
return
delay:	
				
		movlw		0x03		
		movwf		0x53

CONT:	movlw		0xff		
		movwf		0x51
CONT1:	movlw		0xff		
		movwf		0x52
CONT2:	decfsz		0x52,f
		goto		CONT2
		decfsz		0x51,f
		goto		CONT1
		decfsz		0x53,f
		goto		CONT
		return	

end